﻿using System;
using System.Device.I2c;
using System.Text;
using System.Threading;

namespace Myapp
{
    class Program
    {
        static void Main(string[] args)
        {
            // Arduino 从机的地址是 0x15
            I2cConnectionSettings settings = new(1, 0x15);
            // 创建 device 实例
            I2cDevice device = I2cDevice.Create(settings);

            byte input = 0; //读取键盘输入
            Console.WriteLine("现在开始，输入 end 可退出");
            while (true)
            {
                Console.Write("请输入：");
                string sl = Console.ReadLine();
                if (sl.Equals("end", StringComparison.InvariantCultureIgnoreCase))
                {
                    break;
                }
                // 将输入内容转为byte
                if (!byte.TryParse(sl, out input))
                {
                    input = 0;
                }
                /*
                //发送数据
                device.WriteByte(input);
                Thread.Sleep(3);
                // 接收从机发来的数据
                Span<byte> buffer = stackalloc byte[3];
                device.Read(buffer);
                */
                // 可以一步到位，写完就读
                byte[] sendBuf = new byte[] { input };
                byte[] recvBuf = new byte[2];
                device.WriteRead(sendBuf, recvBuf);
                string sr = Encoding.Default.GetString(recvBuf);
                Console.WriteLine("接收到的数据：{0}", sr);
            }
            device.Dispose();
        }
    }
}
