#include <Wire.h>

// 预声明函数
void onRecData(int);
void onRequestData(void);

// 从主机读到的数据
uint8_t readData = 0;

// 要发给主机的数据
// 两个字符 + \0，所以是3字节
// 但这里不需要 \0
char sendData[2] = {};

void setup()
{
    // 该从机的地址是 0x15
    Wire.begin(0x15);
    // 注册函数，当收到主机数据时调用
    Wire.onReceive(onRecData);
    // 注册函数，当主机请求数据时调用
    Wire.onRequest(onRequestData);
}

void loop()
{
    // 根据主机传来的数据设置要发给主机的数据
    switch (readData)
    {
    case 1:
        strcpy(sendData, "SB");
        break;
    case 2:
        strcpy(sendData, "NB");
        break;
    case 3:
        strcpy(sendData, "XB");
        break;
    default:
        strcpy(sendData, "SB");
        break;
    }
}

void onRecData(int count)
{
    if (Wire.available())
    {
        // 读一个字节
        readData = Wire.read();
    }
}

void onRequestData(void)
{
    // 向主机发数据
    Wire.write(sendData);
}